Subject: Re: bug#55887: global-whitespace-mode and WCAG Accessibility Standards

From: "Basil L. Contovounesios" <[email-masked]>
Date: Sat, 11 Jun 2022 16:13:04 +0300

goncholden via "Bug reports for GNU Emacs, the Swiss army knife of text editors" [2022-06-10 17:54 +0000] wrote:

> ------- Original Message -------
> On Friday, June 10th, 2022 at 9:58 PM, Lars Ingebrigtsen <[email-masked]> wrote:
>
>
>> goncholden [email-masked] writes:
>>
>> > I have been using global-whitespace-mode to highlight tabs and trailing spaces.
>> >
>> > Trailing spaces look good in red, but the colour used for highlighting
>> > tabs does not look good when one is using a dark background. Can the
>> > contrast ratio be changed so that it adheres to WCAG Standard used for
>> > Colour Accessibility?
>>
>> The colours look fine to me:
>
> If you look at the contrast ratio, you will find that it is very low, a mere
> 1.59.  You should do some homework to ensure a contrast ratio of at least 4.5:1
> exists between text and background behind the text.
>
> Because it looks good to you, it does not necessarily mean it is good.
> Insisting that it looks good because it is good for you means that the project
> does not care about accessibility.  I cannot see it at all and the thing that
> saved me was having the tab marks showing up.  At a contrast of 3.5, I can see
> it, confirming that the WCAG Standard in a very good standard to use.

Have you tried using one of the Modus themes?  They are bundled with
Emacs since Emacs 28, or you can install them from GNU[-devel] ELPA:

https://elpa.gnu.org/packages/modus-themes.html
https://elpa.gnu.org/devel/modus-themes.html

Quoth (info "(modus-themes) Overview"):

  The Modus themes are designed for accessible readability.  They conform
  with the highest standard for color contrast between any given
  combination of background and foreground values.  This corresponds to
  the WCAG AAA standard, which specifies a minimum rate of distance in
  relative luminance of 7:1.

     Modus Operandi (‘modus-operandi’) is a light theme, while Modus
  Vivendi (‘modus-vivendi’) is dark.  Each theme’s color palette is
  designed to meet the needs of the numerous interfaces that are possible
  in the Emacs computing environment.

For more, see https://protesilaos.com/emacs/modus-themes.

> Rather than simply using grey, the thing to de is select colours from the colour
> wheel (e.g triadic colours) so you can have an adequate colour vibrancy.
> Because whilst you use a vibrant red for trailing spaces, whitespace-mode does
> not continue with the colour vibrancy for highlighting the rest.
>
>>
>> If you want a different colour, then change the colour of that face.

HTH,

-- 
Basil